/*
 *  cache.h
 *  mod_musicindex
 *
 *  $Id: cache.h,v 1.8 2003/07/09 00:47:38 varenet Exp $
 *
 *  Created by Thibaut VARENE on Fri Jul 04 2003.
 *  Copyright (c) 2003 Thibaut VARENE
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1, or (at your option)
 *  any later version.
 *
 */

#ifndef CACHE_H
#define CACHE_H

#include "mod_musicindex.h"
#include <sys/stat.h>	/* file handling */
#include <sys/types.h>	/* file handling */
#include <unistd.h>	/* file handling */
#include <dirent.h>	/* opendir & friends */
#include <stdio.h>	/* fprintf / fscanf */
#include <errno.h>
#include <string.h>

#define CA_FATAL	10	/**< Something bad happened */
#define CA_MISSARG	20	/**< Argument missing */
#define CA_CREATE	30	/**< Requesting file creation */

/** Structure used to exchange data between cache management routines.
 * Currently only designed for flat file cache subsystem. */
typedef struct {
	char *name;	/**< A string generally used to give a pathname. */
	void *stream;	/**< A pointer to a FILE stream or anything else. */
} mu_cache_data;

short cache_check_dir(request_rec *, mu_config *, mu_cache_data *);
short cache_check_file(request_rec *, mu_config *, mu_cache_data *);
mu_ent *cache_read_file(request_rec *, mu_ent *, mu_config *, mu_cache_data *);
short cache_write_file(request_rec *, mu_ent *, mu_config *, mu_cache_data *);

#endif
